;******************************************************************************
;    Filename:        irpaka.asm                                              *
;******************************************************************************
;    Kapcsolra pkhoz, infrarzkelvel                                    *
;******************************************************************************

; Nem kereskedelmi clra szabadon felhasznlhat program, a szerz nem vllal
; rte felelssget.
	list		p=12f1501     ; list directive to define processor
	list		r=dec
	#include	<p12f1501.inc> ; processor specific variable definitions
	#include	<prlx.inc>

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_OFF & _CLKOUTEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _STVREN_OFF & _BORV_LO & _LVP_OFF

   
; defincik:
#define	stad	adcon0,go 
#define	out1	porta,0
#define	in	cm1con0,c1out
#define relay	porta,2		
#define	gomb	porta,3
#define	felez	lass1,0
#define buz	porta,5		; buzzer
#define	sec	flags,0	
#define tilt	flags,1
#define	opto	flags,2
#define	nyolcad	flags,3
#define	sper	flags,4
#define	vper	flags,5
#define	gall	flags,6
selad4	equ	13

	cblock	0x70
	flags
	lass1
	lass2		; scaler
	secreg
	minreg
	ennyi
	ezvolt
	endc

	org     0x0000            
	goto	start
; A megszakts ellltja az infra LED meghajt jelt, sszegyjti a 
; bemeneteket s msodperc alapjelt kpez.     
	org	4
	banksel	0
	bcf	pir1,tmr2if
	banksel	cm1con0
	jb	nyolcad,masik
	; passzv szakasz
	sb	in
	bcf	sper		; bemenet alacsony: sper alacsony (j)
	snb	in
	bsf	sper		; bemenet magas: sper magas (hiba)
	goto	kozos
masik	; aktv szakasz
	sb	in
	bcf	vper		; bemenet alacsony: vper alacsony (tartn)
	snb	in
	bsf	vper
	banksel	0
	snb	gomb		; gombot is csak az aktv szakasz vgn!
	bcf	gall		; gall=0: nem nyomott (tartn)
	sb	gomb
	bsf	gall		; gall=1: nyomott(resetelni)
	banksel	lata
	bcf	lata,0
	bcf	nyolcad
kozos
	banksel	0
	incf	lass1,f
	jnb	lass1,3,sima	; 
	clrf	lass1
	bsf	nyolcad		
	banksel	lata		
	bsf	lata,0		
	banksel	porta		
	incf	lass2,f
	cjnel	lass2,250,sima
	clrf	lass2
	bsf	sec
sima
	retfie

; Fprogram, 4 MHz-re
start
	banksel	ansela
	movlw	16		; ra4 analg bemenet
	movwf	ansela
	banksel option_reg		
	movlw	0x8		; bels felhzk hasznlhatk lennnek
	movwf	option_reg
	movl	trisa,0x1a	; ra4, 3, 1 bemenet
	movl	adcon0,selad4
	banksel	osccon
	movlw	0x68		; 16 mhz=78, 4 mhz=68, 8 mhz=70, 1 mhz=58
	movwf	osccon
	banksel	wpua
	bcf	wpua,1		; opto bemenet felhzja letiltva
	bcf	wpua,4		; analg bemenet felhzja letiltva
	banksel	porta
	clrf	porta
	clrf	tmr2	
	movl	pr2,124		; oszts: 124
	movl	t2con,1		
	bsf	t2con,tmr2on	; t2 fut, megszakts mg nincs
	banksel	daccon0
	movl	daccon0,80h
	movl	daccon1,12
	banksel	cm1con0
	movl	cm1con0,14h
	movl	cm1con1,10h
	banksel	0
	clrf	flags
	clrf	lass1
	movl	lass2,150	; fl msodpercnl rvidebben indul
	clrf	ennyi
	clrf	ezvolt
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	porta
	bsf	intcon,peie
	bsf	intcon,gie
loop1
	jnb	sec,loop1
	bsf	relay
	clrf	minreg
	movl	secreg,1
	bsf	tilt
	bcf	buz
main
	banksel	adcon0
	bsf	stad
loop2
	jb	stad,loop2
	swapf	adresh,w
	banksel	0
	andlw	0x0f		; eredmny fels 4 bitje w als bitjein
	call	mennyi		; behozza a tblzatbl az rtket
	movwf	ennyi		; s elhelyezi elvrt idztsknt
	jnb	tilt,fut	; ha fut az idzts, ezeket tugorja:
	movf	ennyi,w
	movwf	ezvolt		; elz id=elvrt id
	movwf	minreg		; htralev id=elvrt id
	movlw	1
	movwf	secreg		; msodperc(vissza)szmll kezdrtke
	bcf	sec		; sec jelzbit trlse
fut
	swapf	flags,w
	andlw	7
	addwf	pcl,f
	goto	szaml
	goto	hiba
	goto	szun
	goto	hiba
	goto	szun
	goto	hiba
	goto	szun
	goto	hiba
szun
	bsf	tilt
	goto	main
szaml
	bcf	tilt
	movf	ennyi,w		; ha elvrt id=0, vszlells
	jz	leall
	xorwf	ezvolt,w
	jz	loop3		; ha nem vltozott, minek szmoljon?
	movf	ennyi,w
	subwf	ezvolt,w
	sc
	goto	jo		; ha az j nagyobb, nem lehet baj
	subwf	minreg,w
	sc
	goto	leall	; ha a klnbsgnl kevesebb van htra, lell
jo				; minden rendben:
	movf	ezvolt,w
	subwf	ennyi,w
	addwf	minreg,f	; minreg=minreg+j-rgi
	mov	ezvolt,ennyi	; rgi = j
loop3
	jnb	sec,main	; szinkronizci a sec jelhez
	bcf	sec		; sec trlse
	decf	secreg,f	; msodperc cskkentse
	incf	secreg,w	; tviteli felttel meghatrozsa
	jnz	skdec		; tvitel tugrsa, ha nem kell
	movlw	59
	movwf	secreg
	decf	minreg,f	; tvitel 3 lpsben
skdec				; ha volt tvitel, ha nem:
	movf	minreg,f
	jnz	skbuz
	csal	secreg,5	; ha minreg=0 s secreg<6,
	bsf	buz		; akkor szljon a zmmer
	goto	main		; s zrdjon a hurok
skbuz
	incf	minreg,w
	sz
	goto	main-1
leall				; ha minreg=-1, kikapcsol
	bcf	relay
aludj
	sleep			; s mly, vgleges lomba szenderl
	nop
	goto	aludj
hiba	
	goto	szun
	bsf	buz
	goto	aludj
	
; poti tblzat	
mennyi
	addwf	pcl,f
	retlw	0	; azonnal kikapcsol (fkapcsol helyett)
	retlw	5
	retlw	10	; 10 percig 5 perces
	retlw	20
	retlw	30
	retlw	40
	retlw	50
	retlw	60	; 1 rig 10 perces
	retlw	75
	retlw	90
	retlw	105
	retlw	120	; 2 rig 15 perces
	retlw	150
	retlw	180
	retlw	210
	retlw	240	; 4 rig flrs lpsek	

	end
	